
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
    uint s12;
    uint s13;
    uint s14;
    uint s15;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1175;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1452;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _7746;

void main()
{
    int _1165 = gl_InstanceIndex + gl_DrawIDARB;
    int _1166 = readFirstInvocationARB(_1165);
    uint _3114 = uint(gl_VertexIndex);
    uint _3117 = _3114 + _1175.g_cbMainArray._aMain[_1166]._Indices._uiPositionOffset;
    uint _3137 = _3114 + _1175.g_cbMainArray._aMain[_1166]._Indices._uiNormalOffset;
    int _3166 = g_rbTBNs_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3137]._iNormal & 1023;
    int _3169 = (g_rbTBNs_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3137]._iNormal >> 10) & 1023;
    int _3172 = (g_rbTBNs_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3137]._iNormal >> 20) & 1023;
    int _7733;
    if (_3166 > 512)
    {
        _7733 = _3166 | (-1024);
    }
    else
    {
        _7733 = _3166;
    }
    int _7735;
    if (_3169 > 512)
    {
        _7735 = _3169 | (-1024);
    }
    else
    {
        _7735 = _3169;
    }
    int _7737;
    if (_3172 > 512)
    {
        _7737 = _3172 | (-1024);
    }
    else
    {
        _7737 = _3172;
    }
    float _3215 = float(_7733);
    float _3218 = float(_7735);
    float _3221 = float(_7737);
    vec3 _3222 = vec3(_3215, _3218, _3221);
    vec3 _3225 = _3222 * vec3(0.001956947147846221923828125);
    vec4 _3348 = vec4(g_rbVertices_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiPositionsBufferIndex].g_rbVertices[_3117].x, g_rbVertices_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiPositionsBufferIndex].g_rbVertices[_3117].y, g_rbVertices_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiPositionsBufferIndex].g_rbVertices[_3117].z, 1.0);
    vec4 _3349 = g_rbObjects_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiObjectIndex].g_rbObjects[0]._mModel * _3348;
    vec3 _3350 = _3349.xyz;
    mat3 _3507 = mat3(g_rbObjects_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3510 = _3507 * _3225;
    vec2 _3726 = in_uv0 * vec2(2.0);
    vec3 _7679 = _7746;
    _7679.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3726 + vec2(0.300000011920928955078125, -0.0816330015659332275390625), 0.0).x;
    vec3 _3744 = vec3(g_rbMaterialInstances_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3747 = mod(_3744, vec3(2.0));
    vec3 _3751 = _7679 * _3747;
    vec3 _7688 = _7746;
    _7688.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], (in_uv0 * vec2(3.0)) + vec2(-0.20000000298023223876953125, -2.099999904632568359375), 0.0).y;
    vec3 _3781 = _3744 * vec3(0.100000001490116119384765625);
    vec3 _3784 = floor(_3781);
    vec3 _3788 = mod(_3784, vec3(2.0));
    vec3 _3792 = _7688 * _3788;
    vec3 _3796 = vec3(1.0) - _3751;
    vec3 _3799 = vec3(1.0) - _3792;
    vec3 _3800 = _3796 * _3799;
    vec3 _7697 = _7746;
    _7697.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiMaterialIndex].g_rbMaterials[0].s0], _3726, 0.0).z;
    vec3 _3832 = _3744 * vec3(0.00999999977648258209228515625);
    vec3 _3835 = floor(_3832);
    vec3 _3839 = mod(_3835, vec3(2.0));
    vec3 _3843 = _7697 * _3839;
    vec3 _3850 = vec3(1.0) - _3843;
    vec3 _3851 = _3800 * _3850;
    vec3 _3853 = vec3(1.0) - _3851;
    float _3855 = _3853.y;
    float _3860 = _3855 - 0.949999988079071044921875;
    float _3865 = _3860 * 19.9959964752197265625;
    float _3866 = clamp(_3865, 0.0, 1.0);
    float _3867 = mix(0.0, 1.0, _3866);
    float _3875 = _3855 - 0.88999998569488525390625;
    float _3880 = _3875 * 99.90019989013671875;
    float _3881 = clamp(_3880, 0.0, 1.0);
    float _3882 = mix(0.0, 1.0, _3881);
    vec3 _3887 = vec3(_3882);
    vec3 _3888 = mix(vec3(0.0), vec3(-0.011610000394284725189208984375), _3887);
    vec3 _3893 = vec3(_3867);
    vec3 _3894 = mix(_3888, vec3(-0.03869999945163726806640625), _3893);
    vec3 _3900 = _3894 * _3510;
    vec3 _3908 = vec3(g_rbMaterialInstances_Buffer[_1175.g_cbMainArray._aMain[_1166]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3909 = mix(vec3(0.0), _3900, _3908);
    vec3 _3932 = _3350 + _3909;
    float _3997 = _3932.x;
    float _3998 = _3932.y;
    float _3999 = _3932.z;
    vec4 _4000 = vec4(_3997, _3998, _3999, 1.0);
    vec4 _4001 = _1452.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mView * _4000;
    vec4 _4017 = _1452.g_cbPass._EyeData._mCurrentFrameMatrices[0]._mViewJitteredProj * _4000;
    vec4 _7743;
    if (_1452.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4032 = _4017.w;
        vec4 _7744;
        if ((_4017.z / _4032) > 1.0)
        {
            vec4 _7745;
            if (_4001.z > _1452.g_cbPass._fNearPlane)
            {
                vec4 _7710 = _4017;
                _7710.z = _4032;
                _7745 = _7710;
            }
            else
            {
                _7745 = _4017;
            }
            _7744 = _7745;
        }
        else
        {
            _7744 = _4017;
        }
        _7743 = _7744;
    }
    else
    {
        _7743 = _4017;
    }
    interp_instanceID = float(_1165) + 0.5;
    float _3000 = _4001.x;
    float _3001 = _4001.y;
    float _3002 = _4001.z;
    vec4 _3003 = vec4(_3000, _3001, _3002, 1.0);
    float _3004 = dot(_1452.g_cbPass._vfVsClippingPlane[0], _3003);
    float _3005 = -_3004;
    gl_ClipDistance[0] = _3005;
    gl_Position = _7743;
}

